Automatic Analysis (_aa_) software was originally developed by Dr Rhodri Cusack
for supporting research at the MRC Cognition and Brain Science Unit. It
is made available to the academic community in the hope that it may
prove useful.

![CI](https://github.com/automaticanalysis/automaticanalysis/actions/workflows/aa_use_case_test.yml/badge.svg?event=push)
[![Docker image available!](https://img.shields.io/badge/docker-bids%2Faa-brightgreen.svg?logo=docker&style=flat)](https://hub.docker.com/r/bids/aa/)
[![manuscript](https://img.shields.io/badge/doi-10.3389%2Ffninf.2014.00090-blue.svg?style=flat)](http://doi.org/10.3389/fninf.2014.00090)
[![resource](https://img.shields.io/badge/RRID-SCR__003560-blue?style=flat)](https://scicrunch.org/scicrunch/Resources/record/nlx_144509-1/SCR_003560/resolver)
[![DOI](https://zenodo.org/badge/3820833.svg)](https://zenodo.org/badge/latestdoi/3820833)

Definitions: _aa_ means the Automatic Analysis software package and any
associated documentation whether electronic or printed.

# License

Use of this software is subject to the terms of the license, found in
the license.txt file distributed with this software.

# Update #

Please, be aware that this README is not updated anymore; therefore, some information might be outdated and the links might be broken.

The new website at http://automaticanalysis.github.io is now live and should be the primary point of reference.

Please, consult with this README only when you do not find the desired information at http://automaticanalysis.github.io.

# About

aa is a pipeline system for neuroimaging written primarily in Matlab. It
supports SPM 12, as well as selected functions from other software packages 
(e.g., FSL, Freesurfer). The goal is to facilitate automatic, flexible, and 
replicable neuroimaging analyses through a comprehensive pipeline system.

More information can be found on the [_aa_ website](http://automaticanalysis.github.io).

# Help and support

Please feel free to open a discusion thread or an issue here on GitHub if you want to make comment or suggestions or are having trouble getting _aa_ to work.

There is also a discussion list:

https://groups.google.com/d/forum/automaticanalysis

# Software updates

The master branch on github is only updated after testing, so this version is the one to use. Developer versions are maintained in each developer's _aa_ fork on GitHub.

# References and citation

For any papers that report data analyzed with _aa_, please include the
GitHub repo URL and cite the aa paper:

Cusack R, Vicente-Grabovetsky A, Mitchell DJ, Wild CJ, Auer T, Linke AC,
Peelle JE (2015) Automatic analysis (aa): Efficient neuroimaging
workflows and parallel processing using Matlab and XML. Frontiers in
Neuroinformatics 8:90.
http://dx.doi.org/10.3389/fninf.2014.00090
