function Kapp=DirectionalKurt(Dv,Kv,x,neg,MD)
% Compute the value of kurtosis along the direction x
% given voxel's Dv and Kv
% Dv=[D11 D22 D33 D12 D13 D23];
% Kv=[W1111 W2222 W3333 W1112 W1113...
%     W1222 W2223 W1333 W2333 W1122...
%     W1133 W2233 W1123 W1223 W1233];
% Rafael N H
% 07/04/2015


if nargin<4
    
    MD=mean(Dv(1:3)); 
    
    neg=false;
    
elseif nargin == 4
    
    MD=mean(Dv(1:3)); 
    
end

if size(x,2)==2
    az=x(:,1);
    el=x(:,2);
    [xxx, yyy, zzz]=sph2cart(az,el,1);
    gnz=[xxx,yyy,zzz];
else 
    gnz=[x(1),x(2),x(3)]; 
end

Dapp=gnz(1)*gnz(1)*Dv(1)+gnz(2)*gnz(2)*Dv(2)+gnz(3)*gnz(3)*Dv(3)+...
    2*gnz(1)*gnz(2)*Dv(4)+2*gnz(1)*gnz(3)*Dv(5)+2*gnz(2)*gnz(3)*Dv(6);

Wapp=...
    gnz(1)*gnz(1)*gnz(1)*gnz(1)*Kv(1)+...
    gnz(2)*gnz(2)*gnz(2)*gnz(2)*Kv(2)+...
    gnz(3)*gnz(3)*gnz(3)*gnz(3)*Kv(3)+...
    4*gnz(1)*gnz(1)*gnz(1)*gnz(2)*Kv(4)+...
    4*gnz(1)*gnz(1)*gnz(1)*gnz(3)*Kv(5)+...
    4*gnz(1)*gnz(2)*gnz(2)*gnz(2)*Kv(6)+...
    4*gnz(2)*gnz(2)*gnz(2)*gnz(3)*Kv(7)+...
    4*gnz(1)*gnz(3)*gnz(3)*gnz(3)*Kv(8)+...
    4*gnz(2)*gnz(3)*gnz(3)*gnz(3)*Kv(9)+...
    6*gnz(1)*gnz(1)*gnz(2)*gnz(2)*Kv(10)+...
    6*gnz(1)*gnz(1)*gnz(3)*gnz(3)*Kv(11)+...
    6*gnz(2)*gnz(2)*gnz(3)*gnz(3)*Kv(12)+...
    12*gnz(1)*gnz(1)*gnz(2)*gnz(3)*Kv(13)+...
    12*gnz(1)*gnz(2)*gnz(2)*gnz(3)*Kv(14)+...
    12*gnz(1)*gnz(2)*gnz(3)*gnz(3)*Kv(15);
Kapp=(MD/Dapp)^2*Wapp;

if neg
    Kapp=-Kapp;
end