function [De,Da,DTe,DTa,RDe,RDa,V]=EQ10EQ11_Fieremans(Dv,Kv,f,V)

if nargin<4
    load('Dir30_MK.mat')
end

N=size(V,1);

RDe=zeros(N,1);
RDa=RDe;

MD=mean(Dv(1:3));

% Create directional sampling of extracelular and intracelular diffusion
for vt=1:N
    gnz=V(vt,:);
    Dapp=gnz(1)*gnz(1)*Dv(1)+gnz(2)*gnz(2)*Dv(2)+gnz(3)*gnz(3)*Dv(3)+...
        2*gnz(1)*gnz(2)*Dv(4)+2*gnz(1)*gnz(3)*Dv(5)+2*gnz(2)*gnz(3)*Dv(6);
    
    Wapp=...
        gnz(1)*gnz(1)*gnz(1)*gnz(1)*Kv(1)+...
        gnz(2)*gnz(2)*gnz(2)*gnz(2)*Kv(2)+...
        gnz(3)*gnz(3)*gnz(3)*gnz(3)*Kv(3)+...
        4*gnz(1)*gnz(1)*gnz(1)*gnz(2)*Kv(4)+...
        4*gnz(1)*gnz(1)*gnz(1)*gnz(3)*Kv(5)+...
        4*gnz(1)*gnz(2)*gnz(2)*gnz(2)*Kv(6)+...
        4*gnz(2)*gnz(2)*gnz(2)*gnz(3)*Kv(7)+...
        4*gnz(1)*gnz(3)*gnz(3)*gnz(3)*Kv(8)+...
        4*gnz(2)*gnz(3)*gnz(3)*gnz(3)*Kv(9)+...
        6*gnz(1)*gnz(1)*gnz(2)*gnz(2)*Kv(10)+...
        6*gnz(1)*gnz(1)*gnz(3)*gnz(3)*Kv(11)+...
        6*gnz(2)*gnz(2)*gnz(3)*gnz(3)*Kv(12)+...
        12*gnz(1)*gnz(1)*gnz(2)*gnz(3)*Kv(13)+...
        12*gnz(1)*gnz(2)*gnz(2)*gnz(3)*Kv(14)+...
        12*gnz(1)*gnz(2)*gnz(3)*gnz(3)*Kv(15);
    Kapp=(MD*MD)/(Dapp*Dapp)*Wapp; 
    % Eq 10
    RDe(vt)=Dapp*(1+sqrt(Kapp*f/(3*(1-f))));
    % Eq 11
    RDa(vt)=Dapp*(1-sqrt(Kapp*(1-f)/(3*f)));
end

% Create elements of Tensor
n1=V(:,1);
n2=V(:,2);
n3=V(:,3);

NN=[n1.*n1 n2.*n2 n3.*n3 2*n1.*n2 2*n1.*n3 2*n2.*n3];
iNN=pinv(NN);

De=(iNN*RDe)';
Da=(iNN*RDa)';

% Create Tensors
DTe=[De(1) De(4) De(5);...
    De(4) De(2) De(6);...
    De(5) De(6) De(3)];
DTa=[Da(1) Da(4) Da(5);...
    Da(4) Da(2) Da(6);...
    Da(5) Da(6) Da(3)];
