function Mk=MeanKurtosis_rnh(Dv,Kv,g,mode)
% caluclate mean kurtosis
% Inputs:
% Dv=[D11 D22 D33 D12 D13 D23];
% Kv=[W1111 W2222 W3333 W1112 W1113...
%     W1222 W2223 W1333 W2333 W1122...
%     W1133 W2233 W1123 W1223 W1233];
% mode=2 if is given the values of W*Md*Md, which can be
%       useful to avoid divisions from zero
% g is the directions to calculate MK

Nn=size(g,1);
Mk=0;
for v=1:Nn
    Dapp=g(v,1)*g(v,1)*Dv(1)+g(v,2)*g(v,2)*Dv(2)+g(v,3)*g(v,3)*Dv(3)+...
        2*g(v,1)*g(v,2)*Dv(4)+2*g(v,1)*g(v,3)*Dv(5)+2*g(v,2)*g(v,3)*Dv(6);
    Wapp=...
        g(v,1)*g(v,1)*g(v,1)*g(v,1)*Kv(1)+...
        g(v,2)*g(v,2)*g(v,2)*g(v,2)*Kv(2)+...
        g(v,3)*g(v,3)*g(v,3)*g(v,3)*Kv(3)+...
        4*g(v,1)*g(v,1)*g(v,1)*g(v,2)*Kv(4)+...
        4*g(v,1)*g(v,1)*g(v,1)*g(v,3)*Kv(5)+...
        4*g(v,1)*g(v,2)*g(v,2)*g(v,2)*Kv(6)+...
        4*g(v,2)*g(v,2)*g(v,2)*g(v,3)*Kv(7)+...
        4*g(v,1)*g(v,3)*g(v,3)*g(v,3)*Kv(8)+...
        4*g(v,2)*g(v,3)*g(v,3)*g(v,3)*Kv(9)+...
        6*g(v,1)*g(v,1)*g(v,2)*g(v,2)*Kv(10)+...
        6*g(v,1)*g(v,1)*g(v,3)*g(v,3)*Kv(11)+...
        6*g(v,2)*g(v,2)*g(v,3)*g(v,3)*Kv(12)+...
        12*g(v,1)*g(v,1)*g(v,2)*g(v,3)*Kv(13)+...
        12*g(v,1)*g(v,2)*g(v,2)*g(v,3)*Kv(14)+...
        12*g(v,1)*g(v,2)*g(v,3)*g(v,3)*Kv(15);
    Kapp=1/(Dapp*Dapp)*Wapp;
    Mk=Mk+Kapp;
end
Mk=Mk/Nn;

if nargin==4
    if mode~=2
        Md=sum(Dv(1:3))/3;
        Mk=Mk*Md*Md;
    end
else
    Md=sum(Dv(1:3))/3;
    Mk=Mk*Md*Md;
end

    